diff -uNrd ircd-hybrid-6.0/src/res.c ircd-pi1.0a/src/res.c
--- ircd-hybrid-6.0/src/res.c	Fri Nov 24 13:24:37 2000
+++ ircd-pi1.0a/src/res.c	Fri May 10 23:49:05 2002
@@ -4,7 +4,7 @@
  * shape or form. The author takes no responsibility for any damage or loss
  * of property which results from the use of this software.
  *
- * $Id: res.c,v 1.54 2000/11/24 18:24:37 lusky Exp $
+ * $Id: res.c,v 1.2 2002/05/11 03:49:05 smoli Exp $
  *
  * July 1999 - Rewrote a bunch of stuff here. Change hostent builder code,
  *     added callbacks and reference counting of returned hostents.
@@ -382,8 +382,8 @@
       init_resolver();
 #endif 
     if (_res.defdname[0]) {
-      size_t len = strlen(hname);
-      if ((strlen(_res.defdname) + len + 2) < size) {
+      size_t len = irclen(hname);
+      if ((irclen(_res.defdname) + len + 2) < size) {
         hname[len++] = '.';
         strcpy(hname + len, _res.defdname);
       }
@@ -669,7 +669,7 @@
   if (!request) {
     request       = make_request(query);
     request->type = T_A;
-    request->name = (char*) MyMalloc(strlen(hname) + 1);
+    request->name = (char*) MyMalloc(irclen(hname) + 1);
     strcpy(request->name, hname);
   }
   query_name(hname, C_IN, T_A, request);
@@ -841,10 +841,10 @@
    */
   if (alias_count > 0) {
     name = hp->h_aliases[alias_count - 1];
-    name += (strlen(name) + 1);
+    name += (irclen(name) + 1);
   }
   else if (hp->h_name)
-    name = hp->h_name + strlen(hp->h_name) + 1;
+    name = hp->h_name + irclen(hp->h_name) + 1;
   else
     name = request->he.buf + ADDRS_OFFSET + ADDRS_DLEN;
  
@@ -920,7 +920,7 @@
         if (!hp->h_name) {
           strcpy(name, hostbuf);
           hp->h_name = name;
-          name += strlen(name) + 1;
+          name += irclen(name) + 1;
         }
         Debug((DEBUG_INFO,"got ip # %s for %s", 
               inetntoa((char*) hp->h_addr_list[addr_count - 1]), hostbuf));
@@ -962,7 +962,7 @@
       if (!hp->h_name) {
         strcpy(name, hostbuf);
         hp->h_name = name;
-        name += strlen(name) + 1;
+        name += irclen(name) + 1;
       }
       ++answer_count;
       break;
@@ -972,7 +972,7 @@
         strncpy_irc(name, hostbuf, endp - name);
         *alias++ = name;
         *alias   = 0;
-        name += strlen(name) + 1;
+        name += irclen(name) + 1;
       }
       current += rd_length;
       ++answer_count;
@@ -1148,11 +1148,11 @@
   assert(0 != hp);
 
   /* how much buffer do we need? */
-  bytes_needed += (strlen(hp->h_name) + 1);
+  bytes_needed += (irclen(hp->h_name) + 1);
 
   pp = hp->h_aliases;
   while (*pp) {
-    bytes_needed += (strlen(*pp++) + 1 + sizeof(void*));
+    bytes_needed += (irclen(*pp++) + 1 + sizeof(void*));
     ++alias_count;
   }
   pp = hp->h_addr_list;
@@ -1184,7 +1184,7 @@
   /* next write the name */
   new_hp->h.h_name = p;
   strcpy(p, hp->h_name);
-  p += (strlen(p) + 1);
+  p += (irclen(p) + 1);
 
   /* last write the alias list */
   pp = hp->h_aliases;
@@ -1192,7 +1192,7 @@
   while (*pp) {
     *ap++ = p;
     strcpy(p, *pp++);
-    p += (strlen(p) + 1);
+    p += (irclen(p) + 1);
   }
   *ap = 0;
 }
@@ -1214,16 +1214,16 @@
     return -1;
 
   /* how much buffer do we need? */
-  bytes_needed = strlen(hp->h.h_name) + 1;
+  bytes_needed = irclen(hp->h.h_name) + 1;
   pp = hp->h.h_aliases;
   while (*pp) {
-    bytes_needed += (strlen(*pp++) + 1 + sizeof(void*));
+    bytes_needed += (irclen(*pp++) + 1 + sizeof(void*));
     ++alias_count;
   }
   if (alias) {
     pp = alias;
     while (*pp) {
-      bytes_needed += (strlen(*pp++) + 1 + sizeof(void*));
+      bytes_needed += (irclen(*pp++) + 1 + sizeof(void*));
       ++alias_count;
     }
   }
@@ -1267,7 +1267,7 @@
   /* next write the name */
   strcpy(p, hp->h.h_name);
   hp->h.h_name = p;
-  p += (strlen(p) + 1);
+  p += (irclen(p) + 1);
 
   /* last write the alias list */
   pp = hp->h.h_aliases;
@@ -1275,13 +1275,13 @@
   while (*pp) {
     strcpy(p, *pp++);
     *ap++ = p;
-    p += (strlen(p) + 1);
+    p += (irclen(p) + 1);
   }
   if (alias) {
     while (*alias) {
       strcpy(p, *alias++);
       *ap++ = p;
-      p += (strlen(p) + 1);
+      p += (irclen(p) + 1);
     }
   }
   *ap = 0;
@@ -1740,12 +1740,12 @@
     im += sizeof(char *);
     for (i = 0; h->h_aliases[i]; i++) {
       nm += sizeof(char *);
-      nm += strlen(h->h_aliases[i]);
+      nm += irclen(h->h_aliases[i]);
     }
     nm += i - 1;
     nm += sizeof(char *);
     if (h->h_name)
-      nm += strlen(h->h_name);
+      nm += irclen(h->h_name);
   }
   ts = ARES_CACSIZE * sizeof(CacheTable);
   sendto_one(sptr, ":%s %d %s :RES table %d",
diff -uNrd ircd-hybrid-6.0/src/restart.c ircd-pi1.0a/src/restart.c
--- ircd-hybrid-6.0/src/restart.c	Sat Jul 31 04:23:00 1999
+++ ircd-pi1.0a/src/restart.c	Tue May 21 22:14:29 2002
@@ -1,7 +1,7 @@
 /*
  * restart.c
  *
- * $Id: restart.c,v 1.10 1999/07/31 08:23:00 tomh Exp $
+ * $Id: restart.c,v 1.5 2002/05/22 02:14:29 smoli Exp $
  */
 #include "restart.h"
 #include "common.h"
@@ -10,7 +10,9 @@
 #include "struct.h"
 #include "s_debug.h"
 #include "s_log.h"
+#include "config.h"
 
+#include <stdlib.h>
 #include <unistd.h>
 
 /* external var */
@@ -36,7 +38,7 @@
   
   sendto_ops("Aieeeee!!!  Restarting server... memory: %d", get_maxrss());
 
-  log(L_NOTICE, "Restarting server...");
+  log(L_NOTICE, "Restarting server... (SPATH = "SPATH")");
   flush_connections(0);
 
   for (i = 0; i < MAXCONNECTIONS; ++i)
diff -uNrd ircd-hybrid-6.0/src/s_auth.c ircd-pi1.0a/src/s_auth.c
--- ircd-hybrid-6.0/src/s_auth.c	Tue Oct 17 02:20:51 2000
+++ ircd-pi1.0a/src/s_auth.c	Fri May 10 23:49:05 2002
@@ -16,7 +16,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: s_auth.c,v 1.46 2000/10/17 06:20:51 lusky Exp $
+ *   $Id: s_auth.c,v 1.6 2002/05/11 03:49:05 smoli Exp $
  *
  * Changes:
  *   July 6, 1999 - Rewrote most of the code here. When a client connects
@@ -40,6 +40,9 @@
 #include "s_stats.h"
 #include "send.h"
 #include "struct.h"
+#ifdef HAVE_SSL
+#include "ssl.h"
+#endif
 
 #include <netdb.h>               /* struct hostent */
 #include <string.h>
@@ -56,6 +59,8 @@
  * a bit different approach
  * this replaces the original sendheader macros
  */
+
+#ifndef HUB
 static struct {
   const char* message;
   size_t      length;
@@ -71,6 +76,7 @@
   { "NOTICE AUTH :*** Your forward and reverse DNS do not match, " \
     "ignoring hostname.\r\n",                              80 }
 };
+#endif
 
 typedef enum {
   REPORT_DO_DNS,
@@ -83,8 +89,25 @@
   REPORT_IP_MISMATCH
 } ReportType;
 
-#define sendheader(c, r) \
-   send((c)->fd, HeaderMessages[(r)].message, HeaderMessages[(r)].length, 0)
+#ifdef HAVE_SSL
+
+#ifndef HUB
+#define sendheader(c, r) if(!IsSSL((c))) \
+                           send((c)->fd, HeaderMessages[(r)].message, \
+                                         HeaderMessages[(r)].length, 0);
+#else
+#define sendheader(c, r);
+#endif
+
+#else
+
+#ifndef HUB
+#define sendheader(c, r) send((c)->fd, HeaderMessages[(r)].message, HeaderMessages[(r)].length, 0)
+#else
+#define sendheader(c, r);
+#endif
+
+#endif
 
 struct AuthRequest* AuthPollList = 0; /* GLOBAL - auth queries pending io */
 
@@ -175,40 +198,52 @@
   struct AuthRequest* auth = (struct AuthRequest*) vptr;
 
   ClearDNSPending(auth);
-  if (reply) {
-    struct hostent* hp = reply->hp;
-    int i;
-    /*
-     * Verify that the host to ip mapping is correct both ways and that
-     * the ip#(s) for the socket is listed for the host.
-     */
-    for (i = 0; hp->h_addr_list[i]; ++i) {
-      if (memcmp(hp->h_addr_list[i], (char*) &auth->client->ip,
-                      sizeof(struct in_addr)) == 0)
-         break;
-    }
-    if (!hp->h_addr_list[i])
-      sendheader(auth->client, REPORT_IP_MISMATCH);
-    else {
-      ++reply->ref_count;
-      auth->client->dns_reply = reply;
-      strncpy_irc(auth->client->host, hp->h_name, HOSTLEN);
-      sendheader(auth->client, REPORT_FIN_DNS);
+  
+  if(reply)
+    {
+      struct hostent* hp = reply->hp;
+      int i;
+      /*
+       * Verify that the host to ip mapping is correct both ways and that
+       * the ip#(s) for the socket is listed for the host.
+       */
+      
+      for(i = 0; hp->h_addr_list[i]; ++i)
+      {
+        if(memcmp(hp->h_addr_list[i], (char*) &auth->client->ip,
+                  sizeof(struct in_addr)) == 0)
+        break;
+      }
+    
+      if(!hp->h_addr_list[i])
+        {
+          sendheader(auth->client, REPORT_IP_MISMATCH); 
+        }
+      else
+        {
+          ++reply->ref_count;
+          auth->client->dns_reply = reply;
+          strncpy_irc(auth->client->host, hp->h_name, HOSTLEN);
+          sendheader(auth->client, REPORT_FIN_DNS);
+        }
     }
-  }
-  else {
+  else
+    {
     /*
      * this should have already been done by s_bsd.c in add_connection
      */
-    strcpy(auth->client->host, auth->client->sockhost);
-    sendheader(auth->client, REPORT_FAIL_DNS);
-  }
+      strcpy(auth->client->host, auth->client->sockhost);
+      sendheader(auth->client, REPORT_FAIL_DNS);
+    }
+  
   auth->client->host[HOSTLEN] = '\0';
-  if (!IsDoingAuth(auth)) {
-    release_auth_client(auth->client);
-    unlink_auth_request(auth, &AuthIncompleteList);
-    free_auth_request(auth);
-  }
+  
+  if(!IsDoingAuth(auth))
+    {
+      release_auth_client(auth->client);
+      unlink_auth_request(auth, &AuthIncompleteList);
+      free_auth_request(auth);
+    }
 }
 
 /*
@@ -481,7 +516,7 @@
              (unsigned int) ntohs(them.sin_port),
              (unsigned int) ntohs(us.sin_port));
 
-  if (send(auth->fd, authbuf, strlen(authbuf), 0) == -1) {
+  if (send(auth->fd, authbuf, irclen(authbuf), 0) == -1) {
     if (EAGAIN == errno)
       return;
     auth_error(auth);
